theory Nnf
imports "../TermFun"
begin

datatype fm = And fm fm | Or fm fm | Imp fm fm | Iff fm fm | NOT fm | At nat
setup {* Term_Fun.register_datatypes [@{type_name fm}]*}

function (sequential) nnf :: "fm \<Rightarrow> fm" where
  "nnf (At n) = At n"
| "nnf (And p q) = And (nnf p) (nnf q)"
| "nnf (Or p q) = Or (nnf p) (nnf q)"
| "nnf (Imp p q) = Or (nnf (NOT p)) (nnf q)"
| "nnf (Iff p q) = Or (And (nnf p) (nnf q)) (And (nnf (NOT p)) (nnf (NOT q)))"
| "nnf (NOT (And p q)) = Or (nnf (NOT p)) (nnf (NOT q))"
| "nnf (NOT (Or p q)) = And (nnf (NOT p)) (nnf (NOT q))"
| "nnf (NOT (Imp p q)) = And (nnf p) (nnf (NOT q))"
| "nnf (NOT (Iff p q)) = Or (And (nnf p) (nnf (NOT q))) (And (nnf (NOT p)) (nnf q))"
| "nnf (NOT (NOT p)) = nnf p"
| "nnf (NOT p) = NOT p"
  by pat_completeness auto

define_trs (no_sim) nnf.psimps

termination nnf
  apply (trs_reduce nnf)
  apply (simp only: all_trs_defs set_list_conv)
  apply (rule SN_subset[OF _ qrstep_NF_anti_mono, of _ "set []"])
  export_termination_problem "nnf.xml"
  apply (ceta_import_proof "proofs/nnf.proof.xml")
  apply ceta_eval
  apply auto
done

end
